import { ChangeDetectorRef, ElementRef, EventEmitter, OnInit, Renderer2, TemplateRef, ViewContainerRef } from '@angular/core';
import * as i0 from "@angular/core";
export declare class ListboxDirective<T> {
    private renderer;
    private changeDetection;
    static: boolean;
    value: T | null;
    valueChange: EventEmitter<T | null>;
    expanded: boolean;
    windowClickUnlisten: () => void;
    listboxButton: ListboxButtonDirective;
    listboxOptionsPanel: ListboxOptionsPanelDirective;
    listboxOptions: ListboxOptionDirective<T>[];
    activeOption: ListboxOptionDirective<T> | null;
    searchQuery: string;
    searchDebounce: ReturnType<typeof setTimeout> | null;
    constructor(renderer: Renderer2, changeDetection: ChangeDetectorRef);
    toggle(focusAfterExpand?: FocusType<T> | null, focusButtonOnClose?: boolean): void;
    select(value: T | null): void;
    isSelected(value: T | null): boolean;
    focusOption(focusType: FocusType<T>): void;
    clickActive(): void;
    search(value: string): void;
    private calculateFocusedOption;
    private initListeners;
    static ɵfac: i0.ɵɵFactoryDeclaration<ListboxDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ListboxDirective<any>, "[hlListbox]", ["[hlListbox]"], { "static": "static"; "value": "value"; }, { "valueChange": "valueChange"; }, never>;
}
export declare class ListboxButtonDirective implements OnInit {
    private listbox;
    private renderer;
    element: HTMLElement;
    constructor(elementRef: ElementRef, listbox: ListboxDirective<any>, renderer: Renderer2);
    ngOnInit(): void;
    focus(): void;
    private initAttributes;
    static ɵfac: i0.ɵɵFactoryDeclaration<ListboxButtonDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ListboxButtonDirective, "[hlListboxButton]", never, {}, {}, never>;
}
export declare class ListboxOptionsPanelDirective implements OnInit {
    private templateRef;
    private viewContainerRef;
    private listbox;
    private renderer;
    element: HTMLElement | null;
    constructor(templateRef: TemplateRef<any>, viewContainerRef: ViewContainerRef, listbox: ListboxDirective<any>, renderer: Renderer2);
    ngOnInit(): void;
    expand(): void;
    collapse(): void;
    focus(): void;
    private expandInternal;
    private initAttributes;
    private initListeners;
    static ɵfac: i0.ɵɵFactoryDeclaration<ListboxOptionsPanelDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ListboxOptionsPanelDirective, "[hlListboxOptions]", never, {}, {}, never>;
}
export declare class ListboxOptionDirective<T> implements OnInit {
    private templateRef;
    private viewContainerRef;
    private listbox;
    private renderer;
    hlListboxOptionDisabled: boolean;
    hlListboxOptionValue: T | null;
    element: HTMLElement;
    context: {
        active: boolean;
        selected: boolean;
    };
    private view;
    constructor(templateRef: TemplateRef<any>, viewContainerRef: ViewContainerRef, listbox: ListboxDirective<T>, renderer: Renderer2);
    ngOnInit(): void;
    setActive(active: boolean): void;
    select(selected: boolean): void;
    private initAttributes;
    private initListeners;
    static ɵfac: i0.ɵɵFactoryDeclaration<ListboxOptionDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ListboxOptionDirective<any>, "[hlListboxOption]", never, { "hlListboxOptionDisabled": "hlListboxOptionDisabled"; "hlListboxOptionValue": "hlListboxOptionValue"; }, {}, never>;
}
declare type FocusFirst = {
    kind: 'FocusFirst';
};
declare type FocusLast = {
    kind: 'FocusLast';
};
declare type FocusPrevious = {
    kind: 'FocusPrevious';
};
declare type FocusNext = {
    kind: 'FocusNext';
};
declare type FocusNothing = {
    kind: 'FocusNothing';
};
declare type FocusSpecific<T> = {
    kind: 'FocusSpecific';
    option: ListboxOptionDirective<T>;
};
declare type FocusValue<T> = {
    kind: 'FocusValue';
    value: T;
};
declare type FocusType<T> = FocusFirst | FocusLast | FocusPrevious | FocusNext | FocusNothing | FocusSpecific<T> | FocusValue<T>;
export declare class ListboxModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<ListboxModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<ListboxModule, [typeof ListboxDirective, typeof ListboxButtonDirective, typeof ListboxOptionsPanelDirective, typeof ListboxOptionDirective], never, [typeof ListboxDirective, typeof ListboxButtonDirective, typeof ListboxOptionsPanelDirective, typeof ListboxOptionDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<ListboxModule>;
}
export {};
