import { ChangeDetectorRef, ElementRef, OnInit, Renderer2, TemplateRef, ViewContainerRef } from '@angular/core';
import * as i0 from "@angular/core";
export declare class MenuDirective {
    private renderer;
    private changeDetection;
    static: boolean;
    expanded: boolean;
    windowClickUnlisten: () => void;
    menuButton: MenuButtonDirective;
    menuItemsPanel: MenuItemsPanelDirective;
    menuItems: MenuItemDirective[];
    activeItem: MenuItemDirective | null;
    searchQuery: string;
    searchDebounce: ReturnType<typeof setTimeout> | null;
    constructor(renderer: Renderer2, changeDetection: ChangeDetectorRef);
    toggle(focusAfterExpand?: FocusType | null, focusButtonOnClose?: boolean): void;
    focusItem(focusType: FocusType): void;
    clickActive(): void;
    search(value: string): void;
    private calculateFocusedItem;
    private initListeners;
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MenuDirective, "[hlMenu]", ["hlMenu"], { "static": "static"; }, {}, never>;
}
export declare class MenuButtonDirective implements OnInit {
    private menu;
    private renderer;
    element: HTMLElement;
    constructor(elementRef: ElementRef, menu: MenuDirective, renderer: Renderer2);
    ngOnInit(): void;
    focus(): void;
    private initAttributes;
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuButtonDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MenuButtonDirective, "[hlMenuButton]", never, {}, {}, never>;
}
export declare class MenuItemsPanelDirective implements OnInit {
    private templateRef;
    private viewContainerRef;
    private menu;
    private renderer;
    element: HTMLElement | null;
    constructor(templateRef: TemplateRef<any>, viewContainerRef: ViewContainerRef, menu: MenuDirective, renderer: Renderer2);
    ngOnInit(): void;
    expand(): void;
    collapse(): void;
    focus(): void;
    private expandInternal;
    private initAttributes;
    private initListeners;
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuItemsPanelDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MenuItemsPanelDirective, "[hlMenuItems]", never, {}, {}, never>;
}
export declare class MenuItemDirective implements OnInit {
    private templateRef;
    private viewContainerRef;
    private menu;
    private renderer;
    hlMenuItemDisabled: boolean;
    element: HTMLElement;
    private view;
    private context;
    constructor(templateRef: TemplateRef<any>, viewContainerRef: ViewContainerRef, menu: MenuDirective, renderer: Renderer2);
    ngOnInit(): void;
    setActive(active: boolean): void;
    private initAttributes;
    private initListeners;
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuItemDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MenuItemDirective, "[hlMenuItem]", never, { "hlMenuItemDisabled": "hlMenuItemDisabled"; }, {}, never>;
}
declare type FocusFirst = {
    kind: 'FocusFirst';
};
declare type FocusLast = {
    kind: 'FocusLast';
};
declare type FocusPrevious = {
    kind: 'FocusPrevious';
};
declare type FocusNext = {
    kind: 'FocusNext';
};
declare type FocusNothing = {
    kind: 'FocusNothing';
};
declare type FocusSpecific = {
    kind: 'FocusSpecific';
    item: MenuItemDirective;
};
declare type FocusType = FocusFirst | FocusLast | FocusPrevious | FocusNext | FocusNothing | FocusSpecific;
export declare class MenuModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<MenuModule, [typeof MenuDirective, typeof MenuButtonDirective, typeof MenuItemsPanelDirective, typeof MenuItemDirective], never, [typeof MenuDirective, typeof MenuButtonDirective, typeof MenuItemsPanelDirective, typeof MenuItemDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<MenuModule>;
}
export {};
